;;=================================================
;; File: C0WTINY.ASM - Modified Borland C++ 4.0
;;                     Minimal Windows startup code
;; Matt Pietrek 1994
;;=================================================

__C0__ = 1
include         RULES.ASI

ASSUME CS:_TEXT, DS:DGROUP

extrn           WINMAIN:DIST    ; DIST macro defined in RULES.ASI
extrn           INITAPP:far
extrn           INITTASK:far
extrn           FATALEXIT:far
extrn           WAITEVENT:far
extrn           LOCKSEGMENT:far

NULL segment
db      16 dup (0) ; Windows needs 16 bytes at the base of the DGROUP
ends

_DATA           segment
__psp           dw      0
__hInstance     dw      0
__hPrev         dw      0
__pszCmdline    dw      0
__cmdShow       dw      0
ends

_TEXT           segment
Main proc near
    call    INITTASK            ; KERNEL routine
    or      ax,ax
    jz      @@done

    mov     __psp,es            ; These registers set by InitTask
    mov     __pszCmdline,bx
    mov     __hPrev,si
    mov     __hInstance,di
    mov     __cmdShow,dx

    mov     ax,-1
    push    ax
    call    LOCKSEGMENT         ; KERNEL routine

    xor     ax,ax
    push    ax
    call    WAITEVENT           ; USER routine
    push    __hInstance
    call    INITAPP             ; USER routine
    or      ax,ax
    jz      @@done

    push    __hInstance
    push    __hPrev
    push    __psp
    push    __pszCmdline
    push    __cmdShow
    call    WINMAIN             ; Your program's WinMain()

@@done:
    mov     ah,4ch              ; exit program
    int     21h
Main endp
ends
end Main
